using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class TouchController : MonoBehaviour
{
    int numOfKeys;
    GameObject[] doorObject = new GameObject[5];
    int[] openTheDoor = new int[5];
    int openTheDoorNum;
    GameObject canvasObject;
    public bool goal;

    // Start is called before the first frame update
    void Start()
    {
        this.numOfKeys = 0;
        for (int i = 0; i < 5; i++)
        {
            this.doorObject[i] = GameObject.FindWithTag("door" + i);
        }
        bool[] already = new bool[4];
        for (int i = 0; i < 4; i++)
        {
            already[i] = false;
        }
        for (int i = 0; i < 4; i++)
        {
            for (this.openTheDoor[i] = -9; this.openTheDoor[i] == -9;)
            {
                int num = Random.Range(0, 4);
                if (already[num] == false)
                {
                    this.openTheDoor[i] = num;
                    already[num] = true;
                }
            }
        }
        this.openTheDoor[4] = 4;
        this.openTheDoorNum = 0;
        Debug.Log("openTheDoor: " + this.openTheDoor[0] +
            this.openTheDoor[1] + this.openTheDoor[2] +
            this.openTheDoor[3] + this.openTheDoor[4]);
        this.canvasObject = GameObject.FindWithTag("ui");
        this.goal = false;
    }

    // Update is called once per frame
    void Update()
    {
        if (transform.position.y < -30.0f)
        {
            SceneManager.LoadScene(SceneManager.GetActiveScene().name);
        }
    }

    void OnTriggerEnter(Collider collision)
    {
        string tag = collision.gameObject.tag;
        if (tag == "key")
        {
            Destroy(collision.gameObject);
            this.numOfKeys++;
            this.canvasObject.GetComponent<UIController>().GetKey();
        }
        else if (tag == "goal")
        {
            if (this.numOfKeys == 4)
            {
                Destroy(collision.gameObject);
                this.goal = true;
            }
        }
        else if (tag.Length == 5 && tag.Substring(0, 4) == "door")
        {
            int inum = int.Parse(tag.Substring(4, 1));
            if (this.openTheDoor[this.openTheDoorNum] == inum)
            {
                Destroy(collision.gameObject);
                this.openTheDoorNum++;
            }
        }
    }
}
