using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class UIController : MonoBehaviour
{
    GameObject timeObject;
    float time = 0;
    GameObject keyObject;
    GameObject goalObject;
    int yourTime;
    int bestTime;
    GameObject unitychanObject;
    bool waitForRetry;
    public bool resetBestTime = false;

    // Start is called before the first frame update
    void Start()
    {
        this.timeObject = GameObject.FindWithTag("timeui");
        this.time = 0;
        this.keyObject = GameObject.FindWithTag("keyui");
        this.goalObject = GameObject.FindWithTag("goalui");
        if (PlayerPrefs.HasKey("OpenTheDoorBestTime"))
        {
            this.bestTime = PlayerPrefs.GetInt("OpenTheDoorBestTime");
        }
        else
        {
            this.bestTime = 99999999;
        }
        this.unitychanObject = GameObject.FindWithTag("unitychan");
        this.waitForRetry = false;
    }

    // Update is called once per frame
    void Update()
    {
        if (!this.unitychanObject.GetComponent<TouchController>().goal)
        {
            this.time += Time.deltaTime;
            this.timeObject.GetComponent<Text>().text = "Time:" + (int)this.time;
        }
        if (this.unitychanObject.GetComponent<TouchController>().goal &&
                                                           !this.waitForRetry)
        {
            this.yourTime = Mathf.FloorToInt(this.time);
            if (this.yourTime < this.bestTime)
            {
                this.bestTime = this.yourTime;
                PlayerPrefs.SetInt("OpenTheDoorBestTime", this.yourTime);
            }
            this.goalObject.GetComponent<Text>().text = "Game Clear" +
                "\n\nYour Time:" + this.yourTime +
                "\n\nBest Time:" + this.bestTime +
                "\n\nClick To Retry";
            this.waitForRetry = true;
        }
        if (Input.GetMouseButtonDown(0) && this.waitForRetry)
        {
            SceneManager.LoadScene(SceneManager.GetActiveScene().name);
        }
    }

    public void GetKey()
    {
        this.keyObject.GetComponent<Image>().fillAmount += 0.25f;
    }
}
