using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class WarpController : MonoBehaviour
{
    public GameObject warpParticle;
    bool inWarp;
    Vector3 positionInWarp;
    GameObject eGeneratorObject;
    int enemyNum;
    GameObject unitychanObject;
    GameObject uiObject;

    // Start is called before the first frame update
    void Start()
    {
        this.inWarp = false;
        this.eGeneratorObject = GameObject.FindWithTag("enemygenerator");
        this.enemyNum = this.eGeneratorObject.GetComponent<EnemyGenerator>().
            GetEnemyNumber();
        this.unitychanObject = GameObject.FindWithTag("unitychan");
        this.uiObject = GameObject.FindWithTag("ui");
    }

    // Update is called once per frame
    void Update()
    {
        if (this.inWarp)
        {
            transform.position = this.positionInWarp;
        }
    }

    void OnTriggerEnter(Collider collision)
    {
        if (collision.tag == "warpenter" &&
            (this.enemyNum - 1) == 
            this.unitychanObject.GetComponent<UnitychanController>().GetWinNum())
        {
            this.inWarp = true;
            this.positionInWarp = transform.position;
            Instantiate(this.warpParticle, transform.position, 
                Quaternion.Euler(0.0f, 0.0f, 0.0f));
            Invoke("WarpEnterExit", 3.0f);
        }
        if (collision.tag == "warpexit" &&
            this.enemyNum == 
            this.unitychanObject.GetComponent<UnitychanController>().GetWinNum())
        {
            this.inWarp = true;
            this.positionInWarp = transform.position;
            Instantiate(this.warpParticle, transform.position, 
                Quaternion.Euler(0.0f, 0.0f, 0.0f));
            Invoke("WarpReturnExit", 3.0f);
        }
    }

    public void WarpEnterExit()
    {
        GameObject warpPoint;
        warpPoint = GameObject.FindWithTag("warpexit");
        transform.position = warpPoint.transform.position;
        this.positionInWarp = transform.position;
        Instantiate(this.warpParticle, transform.position, 
            Quaternion.Euler(0.0f, 0.0f, 0.0f));
        Invoke("WarpEnterComplete", 3.0f);
    }

    void WarpEnterComplete()
    {
        this.inWarp = false;
    }

    public void WarpReturnExit()
    {
        GameObject warpPoint;
        warpPoint = GameObject.FindWithTag("warpenter");
        transform.position = warpPoint.transform.position;
        this.positionInWarp = transform.position;
        Instantiate(this.warpParticle, transform.position, 
            Quaternion.Euler(0.0f, 0.0f, 0.0f));
        Invoke("WarpReturnComplete", 3.0f);
    }

    void WarpReturnComplete()
    {
        this.inWarp = false;
        this.uiObject.GetComponent<Text>().text = "Saved World";
    }
}
